{{ ir_reader_demo.spin

  Bob Belleville

  This object receives input from an IR remote using
  object ir_reader_nec.spin or ir_reader_sony.spin.

  This is a good tool to use to build a table showing
  the key code for each button.

  see readme.pdf for more documentaton

  2007/03/01 - derived from ir_reader_nec_show.spen
               and tv_terminal_demo.spin
  2007/03/03 - generalized for nec and sony objects
               provide method to get device ID

  2013/01/12  Adapted code to work with Quickstart/Human Interface Board combo
              Codelock uses a 4 digit pin that must be entered in the correct sequence,the OK key is used to enter the pin
              A correct entry flashes all leds 3 times slowly, an incorrect entry flashes all leds rapidly
              When a correct entry is made an output on pin 4 stays on for a few seconds, this could operate an electric lock
              or solenoid or some other device.

              I have left all the original code as is for diagnostic purposes when used with PST,I have added lines that
              show in PST such as flags for Lock Open(LO)True, Lock Closed(LC)False, True(T) False(F),Flag Var(FV)=4 for True
              you can use any digit 0-9 for the code but the Leds stay on so double digits won't show but are still read
              also 0 clears the leds but is still read as part of the code and 9 gives a one shot chase of the leds but is
              still read as part of the code.

              This code is tested with an LG tv remote using the ir_reader_nec.spin
              For another type of remote that's not nec compatible such as sony you will need to unprompt the appropriate
              Obj and then run PST, the first two digits on each line are the keycode pressed,press each of the numbered keys
              and take note of the keycode you will need to modify the lines of code below accordingly,
              lines that need modifying will be the  "if keycode == " replace the 2 digit number after the ==   NOTE: ONLY
              replace the HIB Addition lines of code.
              On the LG remote the keys numbered 0-9 are keycodes 16-25 with the OK key=68
              So to make it easy to change the code for the codelock I used variables A,B,C & D at the beginning of the code
              as you'll see below I had to add 16 ie "if kcp[0] == (A+16) to recognise the number used for variable A 
              on the sony remotes I noticed that the numbered keys are 1 less than the number ie keypad 1 is keycode 0 
              2 is keycode 1 etc so instead of "if kcp[0] == (A+16)for the LG, for the sony you'd replace (A+16) with (A-1)etc
              also the sony remote I have didn't have an OK key so you will need to choose another key and note it's keycode.

              To keep it simple for when reading keycodes using PST I didn't add a delay time for an incorrect entry, you
              may want to add an ever increasing delay to deter someone trying to guess the code
              
              Lines added are commented "HIB Addition"        
               

}}
 
CON

                                'will NOT work at other speeds
        _clkmode        = xtal1 + pll16x
        _xinfreq        = 5_000_000

        _irrpin         = 8     'ir receiver module on this pin  Pin 8 for Human Interface Board
        _device         = 0     'accept any device code
        _dlyrpt         = 6     'delay before acception code as repeat
        
VAR
      Byte LED         'HIB Addition
      Byte kcp[5]      'HIB Addition  Keycodes pressed kept in 5 byte array  only need 4 but 5 to allow for OK keypress
      Byte A,B,C,D,E,F    'HIB Addition
     
OBJ

                                'select one rcvir and one term
                                
         rcvir   : "ir_reader_nec"
        'rcvir   : "ir_reader_sony"
        'rcvir   : "ir_reader_rc5"
        'term    : "tv_terminal"
        term    : "serial_terminal"


PUB start | keycode, x

  
  term.start(12)                'start the tv terminal
  term.str(@title)

  rcvir.init(_irrpin,_device,_dlyrpt,true)   'startup
  
   dira[23..16]:=255            'HIB Addition
   dira[4]:=1
   
   A:= 1                         'HIB Addition  This is your codelock number, change to suit,  default is 1234
   B:= 2
   C:= 3
   D:= 4
 
  repeat
    keycode := rcvir.fifo_get   'try a get from fifo
    if keycode == -1            'empty try again
      next
    
    if keycode & $80
      term.out("R")             'show repeated code
      term.dec(keycode & $7F)
    else
      term.dec(keycode)         'show code
      
      kcp[E]:= keycode           'HIB Addition 
      E := E+1                   'HIB Addition 
     
      
          
      
    if keycode == 17             'LG keypad 1 HIB Addition
     outa[16]:=1                 'HIB Addition
    if keycode == 18             'LG keypad 2 HIB Addition
     outa[17]:=1                 'HIB Addition
    if keycode == 19             'LG keypad 3 HIB Addition
     outa[18]:=1                 'HIB Addition
    if keycode == 20             'LG keypad 4 HIB Addition
     outa[19]:=1                 'HIB Addition
    if keycode == 21             'LG keypad 5 HIB Addition
     outa[20]:=1                 'HIB Addition
    if keycode == 22             'LG keypad 6 HIB Addition
     outa[21]:=1                 'HIB Addition
    if keycode == 23             'LG keypad 7 HIB Addition
     outa[22]:=1                 'HIB Addition
    if keycode == 24             'LG keypad 8 HIB Addition
     outa[23]:=1                 'HIB Addition
    if keycode == 16             'LG keypad 0 HIB Addition
     outa[23..16]:=0             'HIB Addition
    if keycode == 25             'LG keypad 9 HIB Addition
     outa[23..16]:=0             'HIB Addition 
     repeat LED from 16 to 23      'Repeat 8 times, counting forward  HIB Addition 
     
        outa[LED] := 1            'Set LED# on    HIB Addition 
        waitcnt(clkfreq/8 + cnt)  'Wait a moment  HIB Addition
        
    if keycode == 68              'LG Keypad OK  HIB Addition
       sp                         'HIB Addition
       term.out("K")              'HIB Addition
       term.out("e")              'HIB Addition
       term.out("y")              'HIB Addition
       sp                         'HIB Addition
       term.out("C")              'HIB Addition
       term.out("o")              'HIB Addition
       term.out("d")              'HIB Addition
       term.out("e")              'HIB Addition
       term.out("s")              'HIB Addition
       term.out("=")              'HIB Addition
       sp                         'HIB Addition
  
       term.dec (kcp[0])          'HIB Addition
       sp                         'HIB Addition
       term.dec (kcp[1])          'HIB Addition
       sp                         'HIB Addition
       term.dec (kcp[2])          'HIB Addition
       sp                         'HIB Addition
       term.dec (kcp[3])          'HIB Addition
        
      if kcp[0] == (A+16)         'HIB Addition   change as explained in notes 
       F:= F+1                    'HIB Addition
       

      else                        'HIB Addition
        F:=0                      'HIB Addition
       

      if kcp[1] == (B+16)         'HIB Addition   change as explained in notes
       F:=F+1                     'HIB Addition
       
      else                        'HIB Addition
       F:=0                       'HIB Addition

      if kcp[2] == (C+16)         'HIB Addition   change as explained in notes
       F:=F+1                     'HIB Addition

      else                        'HIB Addition
       F:=0                       'HIB Addition

      if kcp[3] == (D+16)         'HIB Addition   change as explained in notes
       F:=F+1                     'HIB Addition

      else                        'HIB Addition
       F:=0                       'HIB Addition
      
      E:=0                        'HIB Addition
      sp                          'HIB Addition
      term.out("F")               'HIB Addition
      term.out("V")               'HIB Addition
      term.dec (F)                'HIB Addition
      sp                          'HIB Addition
       outa[23..16]:=0            'HIB Addition
       
      if F== 4                    'HIB Addition
         outa[4]:=1               'HIB Addition
         sp                       'HIB Addition
         term.out("L")            'HIB Addition
         term.out("O")            'HIB Addition
         sp                       'HIB Addition
        repeat 3                  'HIB Addition
         
         outa [23..16]:=255        'HIB Addition
         waitcnt(clkfreq/2 + cnt)  'HIB Addition
         outa [23..16]:=0          'HIB Addition
         waitcnt(clkfreq/2 + cnt)  'HIB Addition
          F:=0                     'HIB Addition
       
         
        term.out("T")              'HIB Addition
        sp                         'HIB Addition
       
        waitcnt(clkfreq/1 + cnt)   'HIB Addition
        sp                         'HIB Addition
        term.out("L")              'HIB Addition
        term.out("C")              'HIB Addition
        outa[4]:=0                 'HIB Addition
        F:=0   
      else                         'HIB Addition
           
        repeat 6                   'HIB Addition
         outa [23..16]:=255        'HIB Addition
         waitcnt(clkfreq/8 + cnt)  'HIB Addition
         outa [23..16]:=0          'HIB Addition
         waitcnt(clkfreq/8 + cnt)  'HIB Addition
                              'HIB Addition
        term.out("F")              'HIB Addition
         sp                        'HIB Addition
        term.out("L")              'HIB Addition
        term.out("C")              'HIB Addition
        nl                         'HIB Addition
        term.str(String("lock closed....waiting for reboot"))
        waitcnt(clkfreq * 10 + cnt)
        REBOOT
       
  
    sp                             'HIB Addition
    
                                'device code is in low 16 bits
    term.hex(rcvir.fifo_get_lastvalid,8)
    nl
    {
    x := rcvir.fifo_debug       'show fifo head and tail pointers
    term.dec(x>>16 & $FFFF)     'fifo head
    term.out(":")
    term.dec(x & $FFFF)         'fifo tail
    nl
    }
    
    
PUB sp
  term.out(" ")
PUB nl
  term.out(13)
  term.out(10)
    
DAT

title   byte    "Enter IR code.............",13,13,0